regina::NAngleStructureList Class Reference
Angle Structures

A packet representing a collection of angle structures on a triangulation. More...

`#include <angle/nanglestructurelist.h>`

Inheritance diagram for regina::NAngleStructureList:

## Classes

struct | StructureInserter
| An output iterator used to insert angle structures into an NAngleStructureList. More...

## Public Member Functions

virtual | ~NAngleStructureList ()
| Destroys this list and all the angle structures within. More...
NTriangulation * | getTriangulation () const
| Returns the triangulation on which these angle structures lie. More...
bool | isTautOnly () const
| Returns whether this list was produced by enumerating taut angle structures only. More...
unsigned long | getNumberOfStructures () const
| Returns the number of angle structures stored in this list. More...
const NAngleStructure * | getStructure (unsigned long index) const
| Returns the angle structure at the requested index in this list. More...
bool | spansStrict () const
| Determines whether any convex combination of the angle structures in this list is a strict angle structure. More...
bool | spansTaut () const
| Determines whether any angle structure in this list is a taut structure. More...
bool | allowsStrict () const
| Determines whether any convex combination of the angle structures in this list is a strict angle structure. More...
bool | allowsTaut () const
| Determines whether any angle structure in this list is a taut structure. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
virtual bool | dependsOnParent () const
| Determines if this packet depends upon its parent. More...
Public Member Functions inherited from regina::NPacket
| NPacket (NPacket *parent=0)
| Constructor that inserts the new packet into the overall tree structure. More...
virtual | ~NPacket ()
| Destructor that also orphans this packet and destroys all of its descendants. More...
virtual PacketType | getPacketType () const =0
| Returns the unique integer ID representing this type of packet. More...
virtual std::string | getPacketTypeName () const =0
| Returns an English name for this type of packet. More...
const std::string & | getPacketLabel () const
| Returns the label associated with this individual packet. More...
std::string | getHumanLabel () const
| Returns the label associated with this individual packet, adjusted if necessary for human-readable output. More...
void | setPacketLabel (const std::string &newLabel)
| Sets the label associated with this individual packet. More...
std::string | getFullName () const
| Returns a descriptive text string for the packet. More...
std::string | makeUniqueLabel (const std::string &base) const
| Returns a new label that cannot be found anywhere in the entire tree structure. More...
bool | makeUniqueLabels (NPacket *reference)
| Ensures that all packet labels in both this and the given packet tree combined are distinct. More...
bool | hasTag (const std::string &tag) const
| Determines whether this packet has the given associated tag. More...
bool | hasTags () const
| Determines whether this packet has any associated tags at all. More...
bool | addTag (const std::string &tag)
| Associates the given tag with this packet. More...
bool | removeTag (const std::string &tag)
| Removes the association of the given tag with this packet. More...
void | removeAllTags ()
| Removes all associated tags from this packet. More...
const std::set< std::string > & | getTags () const
| Returns the set of all tags associated with this packet. More...
bool | listen (NPacketListener *listener)
| Registers the given packet listener to listen for events on this packet. More...
bool | isListening (NPacketListener *listener)
| Determines whether the given packet listener is currently listening for events on this packet. More...
bool | unlisten (NPacketListener *listener)
| Unregisters the given packet listener so that it no longer listens for events on this packet. More...
NPacket * | getTreeParent () const
| Determines the parent packet in the tree structure. More...
NPacket * | getFirstTreeChild () const
| Determines the first child of this packet in the tree structure. More...
NPacket * | getLastTreeChild () const
| Determines the last child of this packet in the tree structure. More...
NPacket * | getNextTreeSibling () const
| Determines the next sibling of this packet in the tree structure. More...
NPacket * | getPrevTreeSibling () const
| Determines the previous sibling of this packet in the tree structure. More...
NPacket * | getTreeMatriarch () const
| Determines the matriarch (the root) of the tree to which this packet belongs. More...
unsigned | levelsDownTo (const NPacket *descendant) const
| Counts the number of levels between this packet and its given descendant in the tree structure. More...
unsigned | levelsUpTo (const NPacket *ancestor) const
| Counts the number of levels between this packet and its given ancestor in the tree structure. More...
bool | isGrandparentOf (const NPacket *descendant) const
| Determines if this packet is equal to or an ancestor of the given packet in the tree structure. More...
unsigned long | getNumberOfChildren () const
| Returns the number of immediate children of this packet. More...
unsigned long | getNumberOfDescendants () const
| Returns the total number of descendants of this packet. More...
unsigned long | getTotalTreeSize () const
| Determines the total number of packets in the tree or subtree for which this packet is matriarch. More...
void | insertChildFirst (NPacket *child)
| Inserts the given packet as the first child of this packet. More...
void | insertChildLast (NPacket *child)
| Inserts the given packet as the last child of this packet. More...
void | insertChildAfter (NPacket *newChild, NPacket *prevChild)
| Inserts the given packet as a child of this packet at the given location in this packet's child list. More...
void | makeOrphan ()
| Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree. More...
void | reparent (NPacket *newParent, bool first=false)
| Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead. More...
void | swapWithNextSibling ()
| Swaps this packet with its next sibling in the sequence of children beneath their common parent packet. More...
void | moveUp (unsigned steps=1)
| Moves this packet the given number of steps towards the beginning of its sibling list. More...
void | moveDown (unsigned steps=1)
| Moves this packet the given number of steps towards the end of its sibling list. More...
void | moveToFirst ()
| Moves this packet to be the first in its sibling list. More...
void | moveToLast ()
| Moves this packet to be the last in its sibling list. More...
void | sortChildren ()
| Sorts the immediate children of this packet according to their packet labels. More...
NPacket * | nextTreePacket ()
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
const NPacket * | nextTreePacket () const
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
NPacket * | firstTreePacket (const std::string &type)
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
const NPacket * | firstTreePacket (const std::string &type) const
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
NPacket * | nextTreePacket (const std::string &type)
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
const NPacket * | nextTreePacket (const std::string &type) const
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
NPacket * | findPacketLabel (const std::string &label)
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
const NPacket * | findPacketLabel (const std::string &label) const
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
bool | isPacketEditable () const
| Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children. More...
NPacket * | clone (bool cloneDescendants=false, bool end=true) const
| Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet. More...
void | writeXMLFile (std::ostream &out) const
| Writes a complete XML file containing the subtree with this packet as matriarch. More...
std::string | internalID () const
| Returns a unique string ID that identifies this packet. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NAngleStructureList * | enumerate (NTriangulation *owner, bool tautOnly=false, NProgressTracker *tracker=0)
| Enumerates all angle structures on the given triangulation. More...
static NXMLPacketReader * | getXMLReader (NPacket *parent, NXMLTreeResolver &resolver)
Static Public Member Functions inherited from regina::NPacket
static NXMLPacketReader * | getXMLReader (NPacket *parent, NXMLTreeResolver &resolver)
| Returns a newly created XML element reader that will read the contents of a single XML packet element. More...

## Protected Member Functions

| NAngleStructureList (bool tautOnly)
| Creates a new empty angle structure list. More...
virtual NPacket * | internalClonePacket (NPacket *parent) const
| Makes a newly allocated copy of this packet. More...
virtual void | writeXMLPacketData (std::ostream &out) const
| Writes a chunk of XML containing the data for this packet only. More...
void | calculateSpanStrict () const
| Calculate whether the convex span of this list includes a strict angle structure. More...
void | calculateSpanTaut () const
| Calculate whether the convex span of this list includes a taut structure. More...
Protected Member Functions inherited from regina::NPacket
void | writeXMLPacketTree (std::ostream &out) const
| Writes a chunk of XML containing the subtree with this packet as matriarch. More...
Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Friends

class | regina::NXMLAngleStructureListReader

## Additional Inherited Members

Public Types inherited from regina::NPacket
typedef ChangeEventSpan | ChangeEventBlock
| A deprecated typedef for ChangeEventSpan. More...

## Detailed Description

A packet representing a collection of angle structures on a triangulation.

Such a packet must always be a child packet of the triangulation on which the angle structures lie. If this triangulation changes, the information contained in this packet will become invalid.

Angle structure lists should be created using the routine enumerate(), which is new as of Regina 3.95.

Test:
  Included in the test suite.

## Constructor & Destructor Documentation

regina::NAngleStructureList::~NAngleStructureList | ( |  | ) |

inline virtual

Destroys this list and all the angle structures within.

regina::NAngleStructureList::NAngleStructureList | ( | bool | tautOnly | ) |

inline protected

Creates a new empty angle structure list.

All properties are marked as unknown.

Parameters

  tautOnly | `true` if only taut structures are to be enuemrated (when the time comes for enumeration to be performed), or `false` if we should enumerate all vertices of the angle structure solution space.

## Member Function Documentation

bool regina::NAngleStructureList::allowsStrict | ( |  | ) | const

inline

Determines whether any convex combination of the angle structures in this list is a strict angle structure.

Deprecated:
  This routine will be removed in a future version of Regina. Users should switch to the identical routine spansStrict() instead.

Returns
  `true` if and only if a strict angle structure can be produced.

bool regina::NAngleStructureList::allowsTaut | ( |  | ) | const

inline

Determines whether any angle structure in this list is a taut structure.

Deprecated:
  This routine will be removed in a future version of Regina. Users should switch to the identical routine spansTaut() instead.

Returns
  `true` if and only if a taut angle structure can be produced.

void regina::NAngleStructureList::calculateSpanStrict | ( |  | ) | const

protected

Calculate whether the convex span of this list includes a strict angle structure.

void regina::NAngleStructureList::calculateSpanTaut | ( |  | ) | const

protected

Calculate whether the convex span of this list includes a taut structure.

bool regina::NAngleStructureList::dependsOnParent | ( |  | ) | const

inline virtual

Determines if this packet depends upon its parent.

This is true if the parent cannot be altered without invalidating or otherwise upsetting this packet.

Returns
  `true` if and only if this packet depends on its parent.

Implements regina::NPacket.

static NAngleStructureList* regina::NAngleStructureList::enumerate | ( | NTriangulation * | owner,
|  | bool | tautOnly = `false`,
|  | NProgressTracker * | tracker = `0`
| ) |  |

static

Enumerates all angle structures on the given triangulation.

A list containing all vertices of the angle structure solution space will be returned.

The option is offered to find only taut structures (which are considerably faster to enumerate) instead of enumerating all vertex angle structures. See the tautOnly argument below.

The angle structure list that is created will be inserted as the last child of the given triangulation. This triangulation must remain the parent of this angle structure list, and must not change while this angle structure list remains in existence.

If a progress tracker is passed, the angle structure enumeration will take place in a new thread and this routine will return immediately. If the user cancels the operation from another thread, then the angle structure list will not be inserted into the packet tree (but the caller of this routine will still need to delete it). Regarding progress tracking, this routine will declare and work through a series of stages whose combined weights sum to 1; typically this means that the given tracker must not have been used before.

If no progress tracker is passed, the enumeration will run in the current thread and this routine will return only when the enumeration is complete. Note that this enumeration can be extremely slow for larger triangulations.

Parameters

  owner | the triangulation for which the vertex angle structures will be enumerated.
  tautOnly | `true` if only taut structures are to be enuemrated, or `false` if we should enumerate all vertices of the angle structure solution space; this defaults to `false`.
  tracker | a progress tracker through which progress will be reported, or 0 if no progress reporting is required.

Returns
  the newly created angle structure list. Note that if a progress tracker is passed then this list may not be completely filled when this routine returns. If a progress tracker is passed and a new thread could not be started, this routine returns 0 (and no angle structure list is created).

unsigned long regina::NAngleStructureList::getNumberOfStructures | ( |  | ) | const

inline

Returns the number of angle structures stored in this list.

Returns
  the number of angle structures.

const NAngleStructure * regina::NAngleStructureList::getStructure | ( | unsigned long | index | ) | const

inline

Returns the angle structure at the requested index in this list.

Parameters

  index | the index of the requested angle structure in this list; this must be between 0 and getNumberOfStructures()-1 inclusive.

Returns
  the angle structure at the requested index.

NTriangulation* regina::NAngleStructureList::getTriangulation | ( |  | ) | const

Returns the triangulation on which these angle structures lie.

Returns
  the corresponding triangulation.

virtual NPacket* regina::NAngleStructureList::internalClonePacket | ( | NPacket * | parent | ) | const

protected virtual

Makes a newly allocated copy of this packet.

This routine should not insert the new packet into the tree structure, clone the packet's associated tags or give the packet a label. It should also not clone any descendants of this packet.

You may assume that the new packet will eventually be inserted into the tree beneath either the same parent as this packet or a clone of that parent.

Parameters

  parent | the parent beneath which the new packet will eventually be inserted.

Returns
  the newly allocated packet.

Implements regina::NPacket.

bool regina::NAngleStructureList::isTautOnly | ( |  | ) | const

inline

Returns whether this list was produced by enumerating taut angle structures only.

Returns
  `true` if this list was produced by enumerating taut angle structures only, or `false` if the enumeration procedure allowed for any angle structures.

bool regina::NAngleStructureList::spansStrict | ( |  | ) | const

inline

Determines whether any convex combination of the angle structures in this list is a strict angle structure.

See NAngleStructure::isStrict() for details on strict angle structures.

Returns
  `true` if and only if a strict angle structure can be produced.

bool regina::NAngleStructureList::spansTaut | ( |  | ) | const

inline

Determines whether any angle structure in this list is a taut structure.

Because taut structures always appear as vertices of the angle structure solution space, this routine is equivalent to testing whether any convex combination of the angle structures in this list is a taut structure.

See NAngleStructure::isTaut() for details on taut structures.

Returns
  `true` if and only if a taut structure can be produced.

virtual void regina::NAngleStructureList::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

virtual void regina::NAngleStructureList::writeTextShort | ( | std::ostream & | out | ) | const

virtual

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

virtual void regina::NAngleStructureList::writeXMLPacketData | ( | std::ostream & | out | ) | const

protected virtual

Writes a chunk of XML containing the data for this packet only.

You may assume that the packet opening tag (including the packet type and label) has already been written, and that all child packets followed by the corresponding packet closing tag will be written immediately after this routine is called. This routine need only write the internal data stored in this specific packet.

Parameters

  out | the output stream to which the XML should be written.

Implements regina::NPacket.

The documentation for this class was generated from the following file:

- angle/nanglestructurelist.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).